<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  mounted() {
    const observer = new IntersectionObserver(this.updateWidth, {
      rootMargin: '0px',
      threshold: 1,
    });
    const children = Array.from(document.querySelectorAll('.progress'));
    children.forEach((child) => observer.observe(child));
  },
  methods: {
    updateWidth(entries, observer) {
      entries.forEach((entry) => {
        if (entry.isIntersecting) {
          const element = entry.target;
          const width = element.dataset.progress.replace(/\D/g, '');
          const { opacity } = element.dataset;
          element.style.width = `${width}%`;
          element.style.opacity = opacity;
          observer.unobserve(element);
        }
      });
    },
  },
});
</script>

<template>
  <div class="graph-wrapper">
    <div
      v-for="block in data.blocks"
      :key="block.header"
      class="graph-block"
      :class="data.variant"
    >
      <div
        class="header-block"
        :class="{ 'no-header': !block.header }"
        :style="`min-height: ${block.custom_height || 0}px`"
      >
        <SlpTypography
          v-if="block.header"
          class="header"
          variant="heading4-bold"
          >{{ block.header }}</SlpTypography
        >
        <SlpTypography
          v-if="block.description"
          class="description"
          variant="body3"
          >{{ block.description }}</SlpTypography
        >
      </div>
      <div
        v-for="graph in block.graphs"
        :key="graph.name"
        class="graph-container"
      >
        <div class="bar">
          <span
            class="progress"
            :data-progress="graph.value"
            :data-opacity="`${graph.opacity || 1}`"
          />
          <SlpTypography variant="body1-bold" class="value"
            >{{ graph.value }}%</SlpTypography
          >
        </div>
        <SlpTypography variant="body2-bold" tag="p" class="name">{{
          graph.name
        }}</SlpTypography>
      </div>
      <SlpTypography v-if="block.footer" class="footer" variant="body3"
        >* {{ block.footer }}</SlpTypography
      >
    </div>
  </div>
</template>

<style lang="scss" scoped>
.light {
  .header,
  .description {
    color: $color-surface-800;
  }
  .graph-container .bar {
    background-color: #31274b;
  }
  .value {
    color: $color-surface-900;
  }
  .name,
  .footer {
    color: $color-accent-400;
  }
}

.name,
.footer {
  color: $color-accent-500;
}

.footer {
  margin-top: $spacing-32;
  display: block;
}
.header-block {
  &.no-header {
    @media (max-width: $breakpoint-lg) {
      display: none;
    }
  }
  max-width: 450px;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  margin-bottom: $spacing-32;
  .description {
    margin-top: $spacing-8;
  }
}

.graph-wrapper {
  display: flex;
  margin-bottom: $spacing-160;
  .graph-block {
    margin-right: 4rem;
  }
  @media (max-width: $breakpoint-lg) {
    margin-bottom: $spacing-32;
    flex-direction: column;
    .graph-block {
      margin-right: 0;
    }
  }
}

.graph-container {
  margin-bottom: $spacing-32;
  .name {
    max-width: 450px;
  }
  .bar {
    width: 100%;
    max-width: 450px;
    height: 32px;
    background-color: rgba(238, 231, 253, 0.5);
    display: flex;

    @media (min-width: $breakpoint-lg) {
      min-width: 450px;
    }
  }
  .progress {
    opacity: 0.1;
    min-width: 8px;
    height: 32px;
    width: 0;
    background-color: #a989f5;
    border-radius: 0 0 20px 0;
    display: inline-block;
    transition: all 0.8s ease-in;
  }
  .value {
    margin-left: $spacing-8;
  }
}
</style>
